=== debian/changelog ===
ldc (1:0.14.0.dfsg-1build1) wily; urgency=medium

  * No-change rebuild against libconfig++9v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 08 Aug 2015 05:41:59 +0000

ldc (1:0.14.0.dfsg-1) unstable; urgency=medium

  * Remove vcbuild/ files, not useful for a Linux build anyway and non-free.
   Rename version as 0.14.0.dfsg-1. (Closes: #759371)

 -- Konstantinos Margaritis <markos@debian.org>  Tue, 26 Aug 2014 22:50:47 +0300

ldc (1:0.14.0-1) unstable; urgency=medium

   * Just list the supported architectures for now, will add the rest once
    support is properly added, working with upstream to add both kfreebsd and
    powerpc, s390x will follow.
   * Separate phobos2 standard library into separate packages, both static and
    shared libs will be provided.
   * Packaging now kept in git@alioth (Vcs-Git fields updated accordingly,
    Closes: #753967)

 -- Konstantinos Margaritis <markos@debian.org>  Mon, 25 Aug 2014 10:14:15 +0300

ldc (1:0.13.0-1) unstable; urgency=medium

  * New upstream release, that matches dmd 2.064
  * Set /usr/include/dlang/ as install path, to match upstream decision

 -- Konstantinos Margaritis <markos@debian.org>  Tue, 24 Jun 2014 09:52:56 +0300

ldc (0.13.0alpha2-1) unstable; urgency=medium

  * New upstream release
  * Actually change maintainer field in control file
  * Add /usr/include/d/common in the include path, all D external packages will
    be placed there.
  * Also include shared library libldc.so

 -- Konstantinos Margaritis <markos@debian.org>  Thu, 08 Mar 2014 12:03:40 +0200

ldc (0.13.0alpha1-1) unstable; urgency=medium

  * New upstream release. Closes: #726910.
  * New maintainer Closes: #730798.
  * Fixes lots of FTBFS bugs.
    Closes: #625037, #627566, #707372, #654605, #730782.

 -- Konstantinos Margaritis <markos@debian.org>  Mon, 14 Feb 2014 14:19:56 +0200

ldc (0.9.1+hg1634-1) unstable; urgency=low

  * New upstream snapshot:
    - Merge DMD 1.056.
  * debian/patches/06_sh4.diff: Fix build on sh4.  Closes: #560437.
    Thanks to Nobuhiro Iwamatsu.
  * debian/patches/03_ldc-conf.diff: Add /usr/include/d/ldc to include paths.
  * debian/control:
    - Recommends libtango-ldc-dev.  Closes: #561731.
    - Bump Standards-Version to 3.8.4.

 -- Arthur Loiret <aloiret@debian.org>  Sat, 27 Feb 2010 10:55:13 +0000

ldc (0.9.1+hg1596-3) unstable; urgency=low

  * 04_kfreebsd.diff: Add missing hunk to treat kfreebsd-gnu as freebsd.
  * 05_alpha.diff: Port on alpha.

 -- Arthur Loiret <aloiret@debian.org>  Mon, 07 Dec 2009 17:25:49 +0000

ldc (0.9.1+hg1596-2) unstable; urgency=low

  * Link with -Wl,--no-relax on alpha.
  * 04_kfreebsd.diff: Port on kfreebsd-gnu.  Closes: #559350.
    Thanks to Cyril Brulebois <kibi@debian.org> for the patch.
  * debian/ldc.1, debian/ldmd.1: Add manpages.
  * Build in VERBOSE mode.

 -- Arthur Loiret <aloiret@debian.org>  Sat, 05 Dec 2009 15:43:00 +0000

ldc (0.9.1+hg1596-1) unstable; urgency=low

  * Upload to unstable.  Closes: #508070.

 -- Arthur Loiret <aloiret@debian.org>  Thu, 03 Dec 2009 17:33:53 +0000

ldc (0.9.1+hg1596-1~exp1) experimental; urgency=low

  * New upstream snapshot.
    - Merge DMD 1.051.

 -- Arthur Loiret <aloiret@debian.org>  Wed, 02 Dec 2009 17:33:20 +0000

ldc (0.9.1+hg1586-1~exp2) experimental; urgency=low

  * Fix include and library paths in configuration files.

 -- Arthur Loiret <aloiret@debian.org>  Sat, 07 Nov 2009 15:23:50 +0000

ldc (0.9.1+hg1586-1~exp1) experimental; urgency=low

  * Initial release.

 -- Arthur Loiret <aloiret@debian.org>  Sat, 07 Nov 2009 12:10:09 +0000
