=== debian/control ===
Source: ldc
Section: devel
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Konstantinos Margaritis <markos@debian.org>
Build-Depends: debhelper (>= 7), quilt (>= 0.40), cmake, pkg-config (>= 0.20), llvm-3.5-dev, libffi-dev, libconfig-dev, libconfig++-dev, libtinfo-dev, libcurl4-gnutls-dev, zlib1g-dev, libedit-dev
Standards-Version: 3.9.5
Homepage: https://github.com/ldc-developers/ldc
Vcs-Browser: https://alioth.debian.org/anonscm/git/pkg-ldc/pkg-ldc.git
Vcs-Git: git://git.debian.org//git/pkg-ldc/pkg-ldc.git

Package: ldc
Architecture: amd64 armhf i386 
Provides: d-compiler, d-v2-compiler
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libphobos2-ldc-dev, libphobos2-ldc-debug
Description: LLVM D Compiler
 LDC is a compiler for the D programming Language. It is based on the
 latest DMD frontend and uses LLVM as backend.
 .
 LDC already compiles a lot of D code, but should still be considered
 beta quality. Take a look at the tickets to get a better impression
 on what still needs to be implemented.
 .
 This is the actual ldc compiler

Package: libphobos2-ldc-dev
Section: libdevel
Architecture: amd64 armhf i386
Depends: ${shlibs:Depends}, ${misc:Depends}, libphobos2-ldc65 (= ${binary:Version})
Recommends: libphobos2-ldc-debug65 (= ${binary:Version})
Description: LLVM D Compiler - Phobos2 Standard library, imports
 LDC is a compiler for the D programming Language. It is based on the
 latest DMD frontend and uses LLVM as backend.
 .
 LDC already compiles a lot of D code, but should still be considered
 beta quality. Take a look at the tickets to get a better impression
 on what still needs to be implemented.
 .
 This package includes the D imports for Phobos2 Standard Library

Package: libphobos2-ldc65
Section: libdevel
Architecture: amd64 armhf i386 
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libphobos2-ldc-dev (= ${binary:Version})
Description: LLVM D Compiler - Phobos2 Standard library, shared objects
 LDC is a compiler for the D programming Language. It is based on the
 latest DMD frontend and uses LLVM as backend.
 .
 LDC already compiles a lot of D code, but should still be considered
 beta quality. Take a look at the tickets to get a better impression
 on what still needs to be implemented.
 .
 This package includes the libs for Phobos2 Standard Library

Package: libphobos2-ldc-debug65
Section: libdevel
Architecture: amd64 armhf i386 
Depends: ${shlibs:Depends}, ${misc:Depends}, libphobos2-ldc-dev (= ${binary:Version})
Description: LLVM D Compiler - Phobos2 Standard Library, debug libs
 LDC is a compiler for the D programming Language. It is based on the
 latest DMD frontend and uses LLVM as backend.
 .
 LDC already compiles a lot of D code, but should still be considered
 beta quality. Take a look at the tickets to get a better impression
 on what still needs to be implemented.
 .
 This package includes the debug libs for Phobos2 Standard Library
